import { fromString, toString } from "../../common/data/ArrayBuffer";
import { HEADER_BYTE_SIZE, packArrayBufferHeader } from "../../common/data/ArrayBufferPacket";
import { Blob, parseBlobAsArrayBuffer } from "./Blob";
const EMPTY_BLOB = new Blob();
const packBlobPacket = (headerString, payloadBlob = EMPTY_BLOB) => new Blob([ ...packArrayBufferHeader(fromString(headerString)), payloadBlob ]);
const parseBlobPacket = async blobPacket => {
  const headerSize = new DataView(await parseBlobAsArrayBuffer(blobPacket.slice(0, HEADER_BYTE_SIZE))).getUint32(0, !1);
  return [ toString(await parseBlobAsArrayBuffer(blobPacket.slice(HEADER_BYTE_SIZE, HEADER_BYTE_SIZE + headerSize))), blobPacket.slice(HEADER_BYTE_SIZE + headerSize) ];
};
export { packBlobPacket, parseBlobPacket };