import { getRandomId } from "../../common/math/random";
import { isObjectContain } from "../../common/check";
const createKeyCommandHub = ({eventSource = window.document, isSkipPreventDefault = !1}) => {
  const keyCommandMap = new Map();
  const keyCommandListener = event => keyCommandMap.forEach(keyCommand => {
    const {target, checkMap, callback} = keyCommand;
    if ((!target || target.contains(event.target)) && isObjectContain(event, checkMap)) {
      !isSkipPreventDefault && event.preventDefault();
      callback(event, keyCommand);
    }
  });
  let isActive = !1;
  return {
    getIsActive: () => isActive,
    start: () => {
      eventSource.addEventListener("keydown", keyCommandListener);
      isActive = !0;
    },
    stop: () => {
      eventSource.removeEventListener("keydown", keyCommandListener);
      isActive = !1;
    },
    addKeyCommand: ({id = getRandomId(), target, checkMap, callback}) => {
      keyCommandMap.set(id, {
        id,
        target,
        checkMap,
        callback
      });
      return id;
    },
    deleteKeyCommand: ({id}) => keyCommandMap.delete(id)
  };
};
export { createKeyCommandHub };