import { isCompactArrayShallowEqual } from "../../common/immutable/check";
const createSyncStateStorage = ({keyPrefix = "STATE", setItem = (key, value) => window.localStorage.setItem(`${keyPrefix}|${key}`, JSON.stringify(value)), getItem = key => JSON.parse(window.localStorage.getItem(`${keyPrefix}|${key}`)), removeItem = key => window.localStorage.removeItem(`${keyPrefix}|${key}`)}) => {
  let persistState = {};
  let persistKeyList = [];
  const reset = initialPersistState => {
    persistState = {};
    save(initialPersistState);
    return persistState;
  };
  const save = state => {
    const keyList = Object.keys(state);
    for (const key of keyList) persistState[key] !== state[key] && setItem(key, state[key]);
    for (const key of persistKeyList) !state[key] && removeItem(key);
    isCompactArrayShallowEqual(keyList, persistKeyList) || setItem("@@KEY_LIST", keyList);
    persistState = state;
    persistKeyList = keyList;
  };
  const load = () => {
    try {
      const loadKeyList = getItem("@@KEY_LIST") || [];
      persistState = loadKeyList.reduce((o, key) => {
        o[key] = getItem(key);
        return o;
      }, {});
      persistKeyList = loadKeyList;
    } catch (error) {}
    return persistState;
  };
  return {
    reset,
    init: initialState => reset({
      ...initialState,
      ...load()
    }),
    save,
    load
  };
};
export { createSyncStateStorage };