const isString = value => "string" == typeof value;
const isBoolean = value => "boolean" == typeof value;
const isNumber = value => "number" == typeof value;
const isInteger = Number.isInteger;
const isObjectAlike = value => {
  const type = typeof value;
  return "object" === type && null !== value || "function" === type;
};
const isBasicObject = value => "object" == typeof value && null !== value && !Array.isArray(value);
const isObjectKey = (value, key) => isBasicObject(value) && Object.prototype.hasOwnProperty.call(value, key);
const isObjectContain = (value, target) => isBasicObject(value) && Object.entries(target).every(([key, targetValue]) => value[key] === targetValue);
const isBasicArray = Array.isArray;
const isArrayLength = (value, length) => isBasicArray(value) && value.length === length;
const isBasicFunction = value => "function" == typeof value;
const isPromiseAlike = value => Boolean(value && "function" == typeof value.then);
const isOneOf = (value, validList) => validList.includes(value);
const isFunctionThrow = func => {
  try {
    return func() && !1;
  } catch (error) {
    return !0;
  }
};
const isFunctionThrowAsync = async func => {
  try {
    return await func() && !1;
  } catch (error) {
    return !0;
  }
};
const isStrictEqual = (value, target) => Object.is(value, target);
const isStringifyEqual = (value, target) => !!Object.is(value, target) || !(!isObjectAlike(value) || !isObjectAlike(target)) && JSON.stringify(value) === JSON.stringify(target);
export { isString, isBoolean, isNumber, isInteger, isObjectAlike, isBasicObject, isObjectKey, isObjectContain, isBasicArray, isArrayLength, isBasicFunction, isPromiseAlike, isOneOf, isFunctionThrow, isFunctionThrowAsync, isStrictEqual, isStringifyEqual };