const isEqualArrayBuffer = (a, b) => {
  if (a === b) return !0;
  if (a.byteLength !== b.byteLength) return !1;
  const va = new Uint8Array(a);
  const vb = new Uint8Array(b);
  for (let index = 0, indexMax = a.byteLength; index < indexMax; index++) if (va[index] !== vb[index]) return !1;
  return !0;
};
const concatArrayBuffer = (arrayBufferList = []) => {
  const resultTypedArray = new Uint8Array(arrayBufferList.reduce((o, arrayBuffer) => o + arrayBuffer.byteLength, 0));
  let byteOffset = 0;
  arrayBufferList.forEach(arrayBuffer => {
    const {byteLength} = arrayBuffer;
    resultTypedArray.set(new Uint8Array(arrayBuffer), byteOffset);
    byteOffset += byteLength;
  });
  return resultTypedArray.buffer;
};
const deconcatArrayBuffer = (concatedArrayBuffer, byteLengthList, byteOffset = 0) => byteLengthList.map(byteLength => {
  const arrayBuffer = concatedArrayBuffer.slice(byteOffset, byteOffset + byteLength);
  byteOffset += byteLength;
  return arrayBuffer;
});
const PREFIX_ODD = Uint8Array.of(0);
const PREFIX_EVEN = Uint8Array.of(255, 255);
const toString = arrayBuffer => {
  const packArrayBuffer = concatArrayBuffer([ arrayBuffer.byteLength % 2 ? PREFIX_ODD : PREFIX_EVEN, arrayBuffer ]);
  const dataView = new DataView(packArrayBuffer);
  const charCodeList = [];
  for (let index = 0, indexMax = dataView.byteLength / 2; index < indexMax; index++) charCodeList.push(String.fromCharCode(dataView.getUint16(2 * index, !1)));
  return charCodeList.join("");
};
const fromString = (string = "") => {
  const dataView = new DataView(new ArrayBuffer(2 * string.length));
  for (let index = 0, indexMax = string.length; index < indexMax; index++) dataView.setUint16(2 * index, string.charCodeAt(index), !1);
  return dataView.buffer.slice(0 === dataView.getUint8(0) ? PREFIX_ODD.byteLength : PREFIX_EVEN.byteLength);
};
export { isEqualArrayBuffer, concatArrayBuffer, deconcatArrayBuffer, fromString, toString };