const createListMap = () => {
  const map = new Map();
  return {
    clear: () => {
      map.clear();
    },
    add: (mapKey, value) => {
      let list = map.get(mapKey);
      if (void 0 === list) {
        list = [];
        map.set(mapKey, list);
      }
      list.push(value);
    },
    delete: (mapKey, value) => {
      const list = map.get(mapKey);
      const valueIndex = list ? list.indexOf(value) : -1;
      if (-1 === valueIndex) return !1;
      list.splice(valueIndex, 1);
      0 === list.length && map.delete(mapKey);
      return !0;
    },
    get: (mapKey, index) => {
      const list = map.get(mapKey);
      return list && list[index];
    },
    getList: mapKey => map.get(mapKey),
    has: (mapKey, value) => {
      const list = map.get(mapKey);
      return Boolean(list && list.includes(value));
    },
    hasList: mapKey => map.has(mapKey),
    forEach: callback => {
      map.forEach((list, mapKey) => list.forEach(value => callback(value, mapKey)));
    },
    forEachList: callback => {
      map.forEach(callback);
    }
  };
};
export { createListMap };