const rethrowError = error => {
  console.warn(error);
  throw error;
};
const tryCall = (thisArg, name, ...args) => {
  try {
    return thisArg[name](...args);
  } catch (error) {}
};
const catchSync = (func, ...args) => {
  let result, resultError;
  try {
    result = func(...args);
  } catch (error) {
    resultError = error || new Error();
  }
  return {
    result,
    error: resultError
  };
};
const catchAsync = async (func, ...args) => {
  let result, resultError;
  try {
    result = await func(...args);
  } catch (error) {
    resultError = error || new Error();
  }
  return {
    result,
    error: resultError
  };
};
export { rethrowError, tryCall, catchSync, catchAsync };