import { createInsideOutPromise } from "../function";
const createQueueStatus = (size = 0, isValid = !0) => ({
  A: () => size,
  B: () => ++size,
  C: () => --size,
  D: () => isValid,
  E: () => isValid = !1
});
const createAsyncTaskQueue = (onQueueError = (error => {})) => {
  let queueStatus = createQueueStatus();
  let queueTail = Promise.resolve("QUEUE_HEAD");
  return {
    reset: () => {
      queueStatus.E();
      queueStatus = createQueueStatus();
      queueTail = Promise.resolve("QUEUE_HEAD");
    },
    getLength: () => queueStatus.A(),
    pushTask: asyncTask => {
      const {promise, resolve} = createInsideOutPromise();
      const taskPromise = queueTail.then(asyncTask);
      taskPromise.catch(onQueueError).then(() => {
        queueStatus.C();
        queueStatus.D() && resolve();
      });
      queueStatus.B();
      queueTail = promise;
      return taskPromise;
    }
  };
};
export { createAsyncTaskQueue };