const receiveBufferAsync = readableStream => new Promise((resolve, reject) => {
  const data = [];
  readableStream.on("error", reject);
  readableStream.on("data", chunk => data.push(chunk));
  readableStream.on("end", () => {
    readableStream.off("error", reject);
    resolve(Buffer.concat(data));
  });
});
const sendBufferAsync = (writableStream, buffer) => new Promise((resolve, reject) => {
  if (0 === buffer.length) return resolve();
  writableStream.on("error", reject);
  writableStream.write(buffer, () => {
    writableStream.off("error", reject);
    resolve();
  });
});
const toArrayBuffer = buffer => {
  const {buffer: arrayBuffer, byteOffset, byteLength} = buffer;
  return arrayBuffer.byteLength === byteLength ? arrayBuffer : arrayBuffer.slice(byteOffset, byteOffset + byteLength);
};
export { receiveBufferAsync, sendBufferAsync, toArrayBuffer };