import { fromString, toString } from "../../common/data/ArrayBuffer";
import { HEADER_BYTE_SIZE, packArrayBufferHeader } from "../../common/data/ArrayBufferPacket";
import { toArrayBuffer } from "./Buffer";
const EMPTY_BUFFER = Buffer.allocUnsafe(0);
const packBufferPacket = (headerString, payloadBuffer = EMPTY_BUFFER) => Buffer.concat([ ...packArrayBufferHeader(fromString(headerString)).map(arrayBuffer => Buffer.from(arrayBuffer)), payloadBuffer ]);
const parseBufferPacket = bufferPacket => {
  const headerSize = bufferPacket.readUIntBE(0, HEADER_BYTE_SIZE, !0);
  return [ toString(toArrayBuffer(bufferPacket.slice(HEADER_BYTE_SIZE, HEADER_BYTE_SIZE + headerSize))), bufferPacket.slice(HEADER_BYTE_SIZE + headerSize) ];
};
export { packBufferPacket, parseBufferPacket };