const createLogQueue = ({outputStream, queueLengthThreshold = 1024}) => {
  const logQueue = [];
  const pullLog = () => {
    logQueue.push("");
    const string = logQueue.join("\n");
    logQueue.length = 0;
    return string;
  };
  const save = () => {
    0 !== logQueue.length && outputStream.write(pullLog());
  };
  return {
    add: logString => {
      logQueue.push(logString);
      logQueue.length > queueLengthThreshold && save();
    },
    save,
    end: () => {
      0 !== logQueue.length && outputStream.write(pullLog());
      outputStream.end();
    }
  };
};
export { createLogQueue };