import { createHash } from "crypto";
import { receiveBufferAsync } from "../data/Buffer";
const getEntityTagByContentHash = buffer => `"${buffer.length.toString(16)}-${createHash("sha1").update(buffer).digest("base64")}"`;
const getEntityTagByContentHashAsync = async buffer => {
  const length = buffer.length.toString(16);
  const hash = createHash("sha1");
  hash.write(buffer);
  hash.end();
  return `"${length}-${(await receiveBufferAsync(hash)).toString("base64")}"`;
};
const getWeakEntityTagByStat = stat => `W/"${stat.size.toString(16)}-${stat.mtimeMs.toString(16)}"`;
export { getEntityTagByContentHash, getEntityTagByContentHashAsync, getWeakEntityTagByStat };