import { clock } from "../../../common/time";
import { createStateStoreLite } from "../../../common/immutable/StateStore";
const DEFAULT_RESPONDER_ERROR = (store, error) => {
  store.webSocket.doCloseSocket(error);
  store.setState({
    error
  });
};
const createUpdateRequestListener = ({responderList = [], responderError = DEFAULT_RESPONDER_ERROR}) => async (webSocket, request, bodyHeadBuffer) => {
  const stateStore = createStateStoreLite({
    time: clock(),
    error: null,
    protocol: ""
  });
  stateStore.request = request;
  stateStore.response = {
    finished: !0
  };
  stateStore.webSocket = webSocket;
  stateStore.bodyHeadBuffer = bodyHeadBuffer;
  try {
    for (const responder of responderList) await responder(stateStore);
  } catch (error) {
    await responderError(stateStore, error);
  }
  return stateStore.getState().protocol;
};
export { createUpdateRequestListener };