import { createHash, randomBytes } from "crypto";
import { constants as bufferConstants } from "buffer";
const FRAME_CONFIG = {
  COMPLETE: [ 8, 15 ],
  FIRST: [ 0, 15 ],
  MORE: [ 0, 0 ],
  LAST: [ 8, 0 ]
};
const OPCODE_TYPE = {
  CONTINUATION: 0,
  TEXT: 1,
  BINARY: 2,
  CLOSE: 8,
  PING: 9,
  PONG: 10
};
const WEBSOCKET_VERSION = 13;
const WEBSOCKET_EVENT = {
  OPEN: "ws:open",
  FRAME: "ws:frame",
  CLOSE: "ws:close"
};
const getRequestKey = () => randomBytes(16).toString("base64");
const getRespondKey = requestKey => createHash("sha1").update(`${requestKey}258EAFA5-E914-47DA-95CA-C5AB0DC85B11`).digest("base64");
const BUFFER_MAX_LENGTH = bufferConstants.MAX_LENGTH;
const applyMaskQuadletBufferInPlace = (buffer, maskQuadletBuffer) => {
  for (let index = 0, indexMax = buffer.length; index < indexMax; index++) buffer[index] ^= maskQuadletBuffer[3 & index];
};
export { FRAME_CONFIG, OPCODE_TYPE, WEBSOCKET_VERSION, WEBSOCKET_EVENT, getRequestKey, getRespondKey, BUFFER_MAX_LENGTH, applyMaskQuadletBufferInPlace };