import { catchAsync } from "../../common/error";
import { createServer as createNetServer } from "net";
const parseCookieString = cookieString => cookieString.split(";").reduce((o, v) => {
  const [key, ...valueList] = v.split("=");
  const value = valueList.join("=").trim();
  "" !== value && (o[key.trim()] = value);
  return o;
}, {});
const getUnusedPort = (expectPort = 0, hostname = "0.0.0.0") => new Promise((resolve, reject) => {
  const server = createNetServer();
  server.on("error", reject);
  server.listen({
    host: hostname,
    port: expectPort,
    exclusive: !0
  }, error => {
    if (error) return reject(error);
    const {port} = server.address();
    server.close(() => resolve(port));
  });
});
const autoTestServerPort = async (expectPortList, hostname) => {
  for (const expectPort of expectPortList) {
    const {result, error} = await catchAsync(getUnusedPort, expectPort, hostname);
    if (result) return result;
  }
  return getUnusedPort(0, hostname);
};
export { parseCookieString, getUnusedPort, autoTestServerPort };